/*
 * blanco Framework
 * Copyright (C) 2004-2005 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.resourcebundle;

import java.io.File;
import java.util.ArrayList;

import javax.xml.transform.dom.DOMResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import blanco.commons.util.BlancoXmlUtil;
import blanco.resourcebundle.expand.BlancoResourceBundleExpandResourceBundle;
import blanco.resourcebundle.resourcebundle.BlancoResourceBundleResourceBundle;

/**
 * XMLt@C vpeBt@CANZXpJava\[XR[h𐶐܂B
 * 
 * ̃\[XR[hblancoResourceBundlëꕔłB<br>
 * 
 * @author IGA Tosiki
 */
public class BlancoResourceBundleXml2JavaClass {
    /**
     * \[XohANZT̃CX^XB
     */
    private final BlancoResourceBundleResourceBundle fBundle = new BlancoResourceBundleResourceBundle();

    /**
     * \[XohMessageFormatɂp[XsۂɁAO珈𒆒f邩ǂ̃tOB
     * 
     * trueȂ珈fėO𔭐܂B<br>
     * falseȂ珈sAû͖Ƃ݂Ȃ܂B<br>
     * Javã\[XR[hۂȂǂɁA falseɐݒ肵ĔgʂƂł悤ɐ؂ւꍇ܂B<br>
     * ftHgl[true]ݒ肳Ă܂B
     */
    private boolean fIsFailOnMessageFormatError = true;

    /**
     * Oo͂\[XR[hɊ܂߂邩ǂ̃tOB݂͕Wo݂͂̂ɑΉB
     */
    private boolean fIsLog = false;

    /**
     * \[XohMessageFormatɂp[XsۂɁAO珈𒆒f邩ǂ̃tOݒ肵܂B
     * 
     * trueȂ珈fėO𔭐܂B<br>
     * falseȂ珈sAû͖Ƃ݂Ȃ܂B<br>
     * Javã\[XR[hۂȂǂɁA falseɐݒ肵ĔgʂƂł悤ɐ؂ւꍇ܂B<br>
     * ftHgl[true]ݒ肳Ă܂B
     * 
     * @param isFailOnMessageFormatError
     */
    public void setFailOnMessageFormatError(
            final boolean isFailOnMessageFormatError) {
        fIsFailOnMessageFormatError = isFailOnMessageFormatError;
    }

    /**
     * Oo͂\[XR[hɊ܂߂邩ǂ̃tÕZbgB
     * 
     * @param argIsLog
     *            Oo͂\[XR[hɊ܂߂邩ǂB
     */
    public void setLog(final boolean argIsLog) {
        fIsLog = argIsLog;
    }

    /**
     * XMLt@C vpeBt@CANZXpJava\[XR[h𐶐܂B
     * 
     * @param fileSource
     *            ͂ƂȂ钆XMLt@CB
     * @param directoryTarget
     *            \[XR[ho͂ۂ̏o͐fBNgB
     */
    public void process(final File fileSource, final File directoryTarget) {
        final DOMResult result = BlancoXmlUtil.transformFile2Dom(fileSource);

        final Node rootNode = result.getNode();
        if (rootNode instanceof Document) {
            // ꂪnBhLg[g擾
            final Document rootDocument = (Document) rootNode;
            final NodeList listSheet = rootDocument
                    .getElementsByTagName("sheet");
            final int sizeListSheet = listSheet.getLength();
            for (int index = 0; index < sizeListSheet; index++) {
                final Element elementSheet = (Element) listSheet.item(index);
                // System.out.println("V[g[" + elementSheet.getAttribute("name")
                // + "]B");

                final NodeList listCommon = elementSheet
                        .getElementsByTagName(fBundle
                                .getMeta2xmlElementCommon());
                if (listCommon.getLength() == 0) {
                    // commonꍇɂ̓XLbv܂B
                    continue;
                }

                final Element elementCommon = (Element) listCommon.item(0);
                final String baseName = BlancoXmlUtil.getTextContent(
                        elementCommon, BlancoResourceBundleConstants.BASE_NAME);
                if (baseName == null) {
                    continue;
                }

                if (BlancoXmlUtil.getTextContent(elementCommon,
                        BlancoResourceBundleConstants.PACKAGE_NAME) == null) {
                    continue;
                }

                final ArrayList listLocale = new ArrayList();
                final NodeList nodeListCommon = elementCommon
                        .getElementsByTagName(BlancoResourceBundleConstants.LOCALE);
                for (int indexLocale = 0; indexLocale < nodeListCommon
                        .getLength(); indexLocale++) {
                    final Node nodeLook = nodeListCommon.item(indexLocale);
                    if (nodeLook instanceof Element) {
                        final Element elementLook = (Element) nodeLook;
                        final NodeList nodeChields = elementLook
                                .getChildNodes();
                        for (int indexChild = 0; indexChild < nodeChields
                                .getLength(); indexChild++) {
                            final Node nodeChild = nodeChields.item(indexChild);
                            if (nodeChild instanceof Text) {
                                listLocale.add(((Text) nodeChild)
                                        .getNodeValue());
                            }
                        }
                    }
                }
                if (listLocale.size() == 0) {
                    continue;
                }

                expandSheet(elementSheet, elementCommon, directoryTarget);
            }
        }
    }

    /**
     * V[gWJ܂B
     * 
     * \[XR[htOtruȅꍇɂ̂ݐ܂B
     * 
     * @param elementSheet
     *            V[gGgB
     * @param elementCommon
     *            ʃGgB
     * @param directoryTarget
     *            \[XR[ho͂ۂ̏o͐fBNgB
     */
    private void expandSheet(final Element elementSheet,
            final Element elementCommon, final File directoryTarget) {
        new BlancoResourceBundleExpandResourceBundle().expand(elementSheet,
                elementCommon, directoryTarget, fIsFailOnMessageFormatError,
                fIsLog);
    }
}